//=============================================================================
//  t@CċAIɌXbh
//  2008.01.01  BlueLeaf1336 fjtkt@ybb.ne.jp
//=============================================================================

unit FindFile;

interface

uses
    Windows, Classes, SysUtils, SyncObjs;

//=============================================================================
//  Subject: [Delphi-ML:4452] Re: fBNg\𓾂ɂ́H
//=============================================================================
type
    TFindState = (fsIdle,   //  ĂȂ(łIł)
                  fsFind    //  (IOɌfKv)
                  );

    TFindFileThread = class(TThread)
    private
        //  Ώۂ̃pX
        FPathList: TStringList;
        //  
        FResultList: TStringList;
        //  (ǂ)
        FFindState: TFindState;
        //  @艺郌x(:  0: @艺Ȃ : @艺)
        FMaxLevel: Integer;
        //  ̃tH_
        FCurrentPath: String;
        //  𒆒ftO
        FCancel: Boolean;
    public
        //  RXgN^
        constructor Create();
        //  fXgN^
        destructor Destroy(); override;
    public
        //  O猟Ώۂ̃pXǉ
        procedure PutPath(const APath: String);
        //  O猟LZ(f FPathListNA)
        procedure Cancel();
        //  O猟ʂo
        procedure GetResult(AResult: TStrings; const ACount: Integer = 100);
    protected
        //  pXЂƂ FindFiles ɓn
        procedure Execute(); override;
        //  {
        procedure FindFiles(const APath: String; const ALevel: Integer);
        //  Xǧ
        function GetResultCount(): Integer;
    public
        //  O@艺郌xύX
        property MaxLevel: Integer read FMaxLevel write FMaxLevel;
        //  O猟̃tH_mF
        property CurrentPath: String read FCurrentPath;
        //  O猟XǧmF
        property ResultCount: Integer read GetResultCount;
    end;

var
    GFindFileThread: TFindFileThread = nil;

implementation

var
    CS: TCriticalSection;

//=============================================================================
//  TFindFileThread implementation
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TFindFileThread.Create();
begin
    inherited Create(True);

    FPathList := TStringList.Create();
    FPathList.Sorted := True;
    FPathList.Duplicates := dupIgnore;

    FResultList := TStringList.Create();
    FResultList.Duplicates := dupIgnore;

    FFindState := fsIdle;
    FMaxLevel := -1;
    FCurrentPath := '';
    FCancel := False;

    //  FormCreate ŃvpeBݒ Resume();
    //Resume();
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TFindFileThread.Destroy();
begin
    FPathList.Free();
    FResultList.Free();
end;

//-----------------------------------------------------------------------------
//  O猟Ώۂ̃pXǉ
procedure TFindFileThread.PutPath(const APath: String);
begin
    CS.Enter();

    //  tH_Ȃ猟ΏۃXgɒǉ
    if (DirectoryExists(APath)) then
    begin
        FPathList.Add(IncludeTrailingPathDelimiter(APath));
    end
    else
    //  t@CȂ猋ʃXgɒǉ
    if (FileExists(APath)) then
    begin
        FResultList.Add(APath);
    end;

    CS.Leave();
end;

//-----------------------------------------------------------------------------
//  O猟LZ(f FPathListNA)
procedure TFindFileThread.Cancel();
begin
    CS.Enter();

    //  Ώۂ̃XgNA
    FPathList.Clear();
    //  ʃXgNA
    FResultList.Clear();

    CS.Leave();

    //  Ȃ
    if (FFindState = fsFind) then
    begin
        //  f
        FCancel := True;
    end;
end;

//-----------------------------------------------------------------------------
//  O猟ʂo
procedure TFindFileThread.GetResult(AResult: TStrings; const ACount: Integer);
var
    i: Integer;
    LCount: Integer;
begin
    CS.Enter();

    //  o
    LCount := ACount;
    if (LCount > FResultList.Count) then
    begin
        LCount := FResultList.Count;
    end;

    //  oăõXg폜
    for i := 0 to LCount - 1 do
    begin
        AResult.Add(FResultList[0]);
        FResultList.Delete(0);
    end;

    CS.Leave();
end;

//-----------------------------------------------------------------------------
//  pXЂƂ FindFiles ɓn
procedure TFindFileThread.Execute();
var
    LPath: String;
begin
    while (not Terminated) do
    begin
        Sleep(1);
        FCurrentPath := '';
        if (FPathList.Count > 0) then
        begin
            //  Ώۂ̃XgЂƂo
            CS.Enter();
            LPath := FPathList[0];
            FPathList.Delete(0);
            CS.Leave();
            //  s
            FFindState := fsFind;
            FindFiles(LPath, 0);
            FFindState := fsIdle;
            FCancel := False;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  {
procedure TFindFileThread.FindFiles(const APath: String; const ALevel: Integer);
var
    LPath: String;
    LRec: TSearchRec;
begin
    LPath := IncludeTrailingPathDelimiter(APath);
    if (not DirectoryExists(LPath)) then Exit;
    //  ̃pX
    FCurrentPath := APath;

    // Ȃ񂩓Ă邩ȁH
    if FindFirst(LPath + '*.*', faAnyFile, LRec) = 0 then
    begin
        try
            repeat
                //  x`FbN
                if (FMaxLevel >= 0) and (FMaxLevel < ALevel) then Exit;
                //  LZ`FbN
                if (FCancel) then Exit;

                // tH_ƐetH_͖
                if (LRec.Name = '.') or (LRec.Name = '..') then Continue;
                // tH_
                if ((LRec.Attr and faDirectory) <> 0) then
                begin
                    //  @艺
                    FindFiles(LPath + LRec.Name, ALevel + 1);
                end
                //  t@C
                else
                if (FileExists(LPath + LRec.Name)) then
                begin
                    //  ʃXgɒǉ
                    CS.Enter();
                    FResultList.Add(LPath + LRec.Name);
                    CS.Leave();
                end;
            until
                FindNext(LRec) <> 0;
        finally
            FindClose(LRec);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  Xǧ
function TFindFileThread.GetResultCount(): Integer;
begin
    Result := FResultList.Count;
end;

//-----------------------------------------------------------------------------
//  JnEI
initialization
    CS := TCriticalSection.Create();
    GFindFileThread := TFindFileThread.Create();
finalization
    GFindFileThread.Free();
    CS.Free();
end.
 