unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  OleCtrls, StdCtrls, ExtCtrls, ComCtrls, Menus,
  WMPLib_TLB, FindFile;

type
    TTimerThread = class(TThread)
    protected
        procedure Kick();
        procedure Execute; override;
    end;

  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    MenuPlayerProp: TMenuItem;
    N5: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    ComboList: TComboBox;
    PnlMain: TPanel;
    FPlayer: TWindowsMediaPlayer;
    LblOpenState: TLabel;
    LblPlayState: TLabel;
    MenuMinus30: TMenuItem;
    MenuMinus10: TMenuItem;
    MenuPlus10: TMenuItem;
    MenuPlus30: TMenuItem;
    N6: TMenuItem;
    MenuPrevMedia: TMenuItem;
    MenuNextMedia: TMenuItem;
    N7: TMenuItem;
    MenuTrashFile: TMenuItem;
    MenuVersion: TMenuItem;
    TrackBalance: TTrackBar;
    BtnSndVol: TButton;
    N2: TMenuItem;
    MenuConf: TMenuItem;
    MenuRename: TMenuItem;
    MenuMinus60: TMenuItem;
    MenuPlus60: TMenuItem;
    MenuRewindFirst: TMenuItem;
    MenuEndMinus10: TMenuItem;
    N3: TMenuItem;
    MenuMute: TMenuItem;
    MenuVolume10: TMenuItem;
    MenuVolume20: TMenuItem;
    MenuVolume30: TMenuItem;
    MenuVolume40: TMenuItem;
    MenuVolume50: TMenuItem;
    MenuVolume60: TMenuItem;
    MenuVolume70: TMenuItem;
    MenuVolume80: TMenuItem;
    MenuVolume90: TMenuItem;
    MenuVolume0: TMenuItem;
    MenuVolume100: TMenuItem;
    LblStatusTxt: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FPlayerPlayStateChange(Sender: TObject; NewState: Integer);
    procedure FPlayerOpenStateChange(Sender: TObject; NewState: Integer);
    procedure FPlayerStatusChange(Sender: TObject);
    procedure FPlayerMediaChange(Sender: TObject; const Item: IDispatch);
    procedure FormDestroy(Sender: TObject);
    procedure MenuPlayerPropClick(Sender: TObject);
    procedure FPlayerClick(Sender: TObject; nButton, nShiftState: Smallint;
      fX, fY: Integer);
    procedure FormResize(Sender: TObject);
    procedure ComboListSelect(Sender: TObject);
    procedure BtnMinus30Click(Sender: TObject);
    procedure MenuNextMediaClick(Sender: TObject);
    procedure MenuTrashFileClick(Sender: TObject);
    procedure MenuVersionClick(Sender: TObject);
    procedure TrackBalanceChange(Sender: TObject);
    procedure BtnSndVolClick(Sender: TObject);
    procedure MenuConfClick(Sender: TObject);
    procedure MenuRenameClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure MenuEndMinus10Click(Sender: TObject);
    procedure MenuVolume90Click(Sender: TObject);
  private
    FTimerThread: TTimerThread;
    FCounter: Integer;
    procedure UpdateForm();
  private
    FClientWndProc: Pointer;
    FOrgWndProc: Pointer;
    AllocHandle:HWND;
    FStrBuf: TStringList;
    procedure ClientWndProc(var Msg: TMessage);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
  private
    procedure ShowStatus(const S: string; const index: integer);
    procedure SetPrevMedia();
    procedure SetNextMedia();
    procedure PlayOrPause();
  end;

var
  MainForm: TMainForm;

//-----------------------------------------------------------------------------
//  dNp̔閧̒l[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
const                  
    UNIQUE_NAM: string = '{BBD4BEB9-6735-4686-AC6E-589E617395F5}';
    UNIQUE_NUM: Cardinal = $00001111;

implementation

uses
    ShellApi, ActiveX, Info, Prop, Config;

const
    PLAYER_STOP = '~';
    PLAYER_READY = '';
    INDEX_TIME = 0;
    INDEX_SIZE = 1;
    INDEX_CANCEL = 2;

{$R *.dfm}

//=============================================================================
//  TTimerThread implementation
//=============================================================================

//-----------------------------------------------------------------------------
procedure TTimerThread.Kick();
begin
    MainForm.UpdateForm();
end;

//-----------------------------------------------------------------------------
procedure TTimerThread.Execute();
begin
    while not Terminated do
    begin
        Synchronize(Kick);
        Sleep(10);
    end;
end;

//=============================================================================
//  TMainForm implementation
//=============================================================================

//-----------------------------------------------------------------------------
//  j[NȃNXw肵ăbZ[WMpEBhE֐[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
function AllocMsgWnd(Method: TWndMethod; ClassName:string): HWND;
var
    DummyClass: TWndClass;
begin
    FillChar(DummyClass, SizeOf(TWndClass), #0);
    DummyClass.hInstance := hInstance;
    DummyClass.lpfnWndProc := @DefWindowProc;
    DummyClass.lpszClassName := PChar(ClassName);
    Windows.RegisterClass(DummyClass);
    Result := CreateWindowEx(WS_EX_TOOLWINDOW, DummyClass.lpszClassName,
                             '', WS_POPUP, 0, 0, 0, 0, 0, 0, hInstance, nil);
    if Assigned(Method) then
        SetWindowLong(Result,GWL_WNDPROC,LongInt(Classes.MakeObjectInstance(Method)));
end;

//-----------------------------------------------------------------------------
//  RXgN^[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    // \bhƂĒ`EBhEvV[WGg|Cg쐬
    FClientWndProc := Classes.MakeObjectInstance(ClientWndProc);
    // 쐬łAMDI NCAg̃EBhEvV[WƂ
    // o^ÃGgۑ
    if FClientWndProc <> nil then
    begin
        FOrgWndProc := Pointer(SetWindowLong(ClientHandle, GWL_WNDPROC,
                                            Longint(FClientWndProc)));
    end;
    //  bZ[WMp
    if AllocHandle = 0 then AllocHandle := AllocMsgWnd(ClientWndProc, UNIQUE_NAM);
end;

//-----------------------------------------------------------------------------
//  fXgN^[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
destructor TMainForm.Destroy;
begin
    // fXgN^ŃEBhEvV[Wɖ߂
    if FOrgWndProc <> nil then
    begin
        SetWindowLong(ClientHandle, GWL_WNDPROC, Longint(FOrgWndProc));
    end;
    //  bZ[WMp
    Classes.DeallocateHwnd(AllocHandle);
    AllocHandle := 0;
    inherited;
end;

//-----------------------------------------------------------------------------
//  ւp̃EBhEvV[W[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=268
procedure TMainForm.ClientWndProc(var Msg: TMessage);
var
    i: integer;
    LBuf: PChar;
    LCopyData: PCopyDataStruct;
begin
    case Msg.Msg of

    //  ʂ̃CX^X瑗Ăe
    WM_COPYDATA:
        begin
            LCopyData := PCopyDataStruct(Msg.LParam);
            if LCopyData^.dwData = UNIQUE_NUM then
            begin
                LBuf := StrALloc(LCopyData^.cbData);
                try
                    StrCopy(LBuf, LCopyData^.lpData);
                    FStrBuf.CommaText := LBuf;
                finally
                    StrDispose(LBuf);
                end;
                for i := 0 to FStrBuf.Count - 1 do
                begin
                    //  Xbhɒǉ
                    GFindFileThread.PutPath(FStrBuf.Strings[i]);
                end;
            end;
        end;

    //  ̑̑SĂ̏ꍇ
    else
        Msg.Result := CallWindowProc(FOrgWndProc, ClientHandle,
                                        Msg.Msg, Msg.WParam, Msg.LParam);
    end;
end;

//-----------------------------------------------------------------------------
//  tH[\[2008/01/16]
procedure TMainForm.FormShow(Sender: TObject);
var
    i: integer;
begin
    //  NɃACRɃhbvꂽt@C
    for i := 1 to ParamCount do
    begin
        //  Xbhɒǉ
        GFindFileThread.PutPath(ParamStr(i));
    end;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    LPathName: Array[0..MAX_PATH] of Char;
    i, LCount: integer;
begin
    //  hbvꂽt@C̐擾
    LCount := DragQueryFile(Msg.Drop, DWORD(-1), LPathName, SizeOf(LPathName));
    for i := 0 to LCount - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, LPathName, SizeOf(LPathName));
        //  Xbhɒǉ
        GFindFileThread.PutPath(LPathName);
    end;
    //  hbv
    DragFinish(Msg.Drop);
end;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  RXgN^
//  http://hpcgi1.nifty.com/MADIA/DelphiBBS/wwwlng.cgi?print+200711/07110026.txt
//  WindowsMediaPlayer1ς̍Đ\ɂ́H
procedure TMainForm.FormCreate(Sender: TObject);
var
    LCore: IWMPCore;
    LPlayer4Disp: WMPLib_TLB.IWMPPlayer4Disp;
begin
    LblOpenState.Caption := '';
    LblPlayState.Caption := '';
    LblStatusTxt.Caption := '';

    //  ݒǂݍ
    GConfig := TConfig.Create();
    GConfig.LoadConfig(ChangeFileExt(ParamStr(0), '.ini'));

    //  GpXg쐬
    FStrBuf := TStringList.Create;

    //  vC[̃C^[tF[Xo(?)
    LCore := FPlayer.ControlInterface;
    if Assigned(LCore) then
    begin
        //  StretchToFit ĂC^[tF[Xւ̎QƂo
        LCore.QueryInterface(WMPLib_TLB.IWMPPlayer4Disp, LPlayer4Disp);
        if Assigned(LPlayer4Disp) then
        begin
            //  ŁAݒ肷
            LPlayer4Disp.StretchToFit := True;
        end;
    end;

    FCounter := 0;
    FTimerThread := TTimerThread.Create(False);
    GFindFileThread.Resume();
end;

//-----------------------------------------------------------------------------
//  tH[TCYɒǏ]
//  BBS ւ̏(2007/12 ern )
procedure TMainForm.FormResize(Sender: TObject);
const
    IID_IOleInPlaceObject: TGUID = '{00000113-0000-0000-C000-000000000046}';
var
    IOIPObj: IOleInPlaceObject;
    WMPRect: TRect;
begin
    SetRect(WMPRect, 0, 0, PnlMain.Width, PnlMain.Height);
    IDispatch(FPlayer.OleObject).QueryInterface(IID_IOleInPlaceObject, IOIPObj);
    if Assigned(IOIPObj) then
    begin
        IOIPObj.SetObjectRects(WMPRect, WMPRect);
    end;
end;

//-----------------------------------------------------------------------------
//  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    FTimerThread.Free();
    //  LZ
    GFindFileThread.Cancel();

    //  ݒۑ
    GConfig.SaveConfig(ChangeFileExt(ParamStr(0), '.ini'));
    GConfig.Free();

    FStrBuf.Free;
end;

//-----------------------------------------------------------------------------
//  Xe[^Xo[ɃbZ[W\
procedure TMainForm.ShowStatus(const S: string; const index: integer);
begin
    StatusBar.Panels[index].Text := S;
end;

//-----------------------------------------------------------------------------
//  Ƃ߂
procedure TMainForm.BtnMinus30Click(Sender: TObject);
var
    LSender: TComponent;
begin
    LSender := TComponent(Sender);
    if (FPlayer.currentMedia <> nil) then
    begin
        FPlayer.controls.currentPosition
            := FPlayer.controls.currentPosition + LSender.Tag;
    end;
end;

//-----------------------------------------------------------------------------
//  Ƃ߂[2008/01/16]
procedure TMainForm.MenuEndMinus10Click(Sender: TObject);
var
    LSender: TMenuItem;
begin
    LSender := TMenuItem(Sender);
    if (FPlayer.currentMedia <> nil) then
    begin
        if (LSender = MenuRewindFirst) then
        begin
            FPlayer.controls.currentPosition := 0;
        end
        else
        if (LSender = MenuEndMinus10) then
        begin
            FPlayer.controls.currentPosition
                := FPlayer.currentMedia.duration - 10;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ʒ[2008/01/16]
procedure TMainForm.MenuVolume90Click(Sender: TObject);
var
    LSender: TComponent;
begin
    LSender := TComponent(Sender);
    if (LSender.Tag < 0) then
    begin
        FPlayer.settings.mute := not FPlayer.settings.mute;
    end
    else
    begin
        FPlayer.settings.volume := LSender.Tag;
    end;
end;

//-----------------------------------------------------------------------------
//  ^C}[
procedure TMainForm.UpdateForm();
var
    s, s1, s2: string;
    d1, d2: Double;
    LBuf: TStringList;
    i: Integer;
begin
    //  hbvt@CfBAXgɒǉ
    if (GFindFileThread.ResultCount > 0) then
    begin
        //  f
        ShowStatus('[ESC] to Break', INDEX_CANCEL);
        if (GetAsyncKeyState(VK_ESCAPE) <> 0) then
        begin
            GFindFileThread.Cancel();
        end;

        LBuf := TStringList.Create();
        LBuf.Sorted := True;
        GFindFileThread.GetResult(LBuf, 10);
        for i := 0 to LBuf.Count - 1 do
        begin
            //  `FbN
            if (not GConfig.CheckFile(LBuf[i])) then Continue;

            //  vCXgɒǉƖΉ̃t@C͂B
            //  FLVȂǂ̕WȊO(?)̃t@CĐłꍇłB
            //  Ȃ̂ŁAOŃXgǗAĐsourceURLw肷B
            ComboList.Items.Add(LBuf[i]);

            //  AĐĂȂ΍ĐĂ݂
            if (FPlayer.status = PLAYER_READY)
            or (FPlayer.status = '') then
            begin
                SetNextMedia();
            end;
        end;
    end
    else
    begin
        ShowStatus('', INDEX_CANCEL);
    end;

    //  AĐĂȂ΍ĐĂ݂
    //  ̃ubNȂ flv t@CȂǕWT|[gÕt@CXLbv
    //  ƁAŌ̃fBAxĐĂ܂
    if (ComboList.ItemIndex <> -1) then
    begin
        if (FPlayer.status = PLAYER_READY)
        or (FPlayer.status = '') then
        begin
            FPlayer.controls.play();
            //SetNextMedia();
        end;
    end;

    //  Đ̃fBA̎ԂɊւ\
    if (FPlayer.currentMedia <> nil) then
    begin
        //  ݂̃fBAڂ̕bŎĐ(b)
        s1 := FPlayer.currentMedia.durationString;
        //  fBAړ݈̌ʒu擾(b)
        s2 := FPlayer.controls.currentPositionString;
        if (s2 = '') then s2 := '00:00';
        //  ݂̃fBAڂ̕bŎĐ
        d1 := FPlayer.currentMedia.duration;
        //  fBAړ݈̌ʒu擾(ύX\)
        d2 := FPlayer.controls.currentPosition;
        //  A
        s := Format('%s(%fb) / %s(%fb)', [s2, d2, s1, d1]);

        ShowStatus(s, INDEX_TIME);

        //  ĐIŎ̃fBAɈړ
        //  ĐĂȂ΍ĐĂ݂
        if (FPlayer.status = PLAYER_STOP)
        //or (FPlayer.status = PLAYER_READY)
        or (FPlayer.status = '') then
        begin
            SetNextMedia();
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  fBAύXꂽ
procedure TMainForm.FPlayerMediaChange(Sender: TObject; const Item: IDispatch);
var
    LMedia: IWMPMedia;
    LName: String;
    LWidth: Integer;
    LHeight: Integer;
begin
    LMedia := Item as IWMPMedia;
    LName := LMedia.name;
    LWidth := LMedia.imageSourceWidth;
    LHeight := LMedia.imageSourceHeight;
    Self.Caption := Format('%s %dx%D %s', [Application.Title, LWidth, LHeight, LName]);
end;

//-----------------------------------------------------------------------------
//  ĐEꎞ~[2008/01/15]
procedure TMainForm.PlayOrPause();
begin
    if (FPlayer.controls.isAvailable['Play']) then
    begin
        FPlayer.controls.play();
    end
    else if (FPlayer.controls.isAvailable['Pause']) then
    begin
        FPlayer.controls.pause();
    end;
end;

//-----------------------------------------------------------------------------
//  ĐE~(}EXNbN)
procedure TMainForm.FPlayerClick(Sender: TObject; nButton,
  nShiftState: Smallint; fX, fY: Integer);
var
    LRect: TRect;
begin
    //  ^񒆕t߂NbNĐEꎞ~؂ւ
    LRect := FPlayer.ClientRect;
    InflateRect(LRect, -50, -50);
    OffsetRect(LRect, 0, -50);
    if not (PtInRect(LRect, Point(fX, fY))) then
    begin
        inherited;
        Exit;
    end;

    PlayOrPause();
end;

//-----------------------------------------------------------------------------
//  ĐE~(Xy[XL[)[2008/01/15]
procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = VK_SPACE) then
    begin
        PlayOrPause();
    end;
end;

//-----------------------------------------------------------------------------
// t@CI
procedure TMainForm.ComboListSelect(Sender: TObject);
var
    LSize: Integer;
begin
    if (ComboList.ItemIndex = -1) then exit;
    //  Ôߍ̃fBA~Ă
    FPlayer.controls.stop;
    //  fBA؂ւ
    try
        FPlayer.URL := ComboList.Text;
        if (FPlayer.URL <> '') then
        begin
            LSize := FileSizeByFileSize(FPlayer.URL);
            ShowStatus(Format('%.2f[MB]', [LSize / (1024 * 1024)]), INDEX_SIZE);
            FPlayer.controls.play;
        end;
    except
        ;
    end;
end;

//-----------------------------------------------------------------------------
//  ЂƂÕfBA
procedure TMainForm.SetPrevMedia();
begin
    if (ComboList.Items.Count > 0) and (ComboList.ItemIndex > 0) then
    begin
        ComboList.ItemIndex := ComboList.ItemIndex - 1;
        ComboList.OnSelect(ComboList);
    end
    //  OȂ΃NA(ǃNAȂ)
    //  status uvɂȂ
    else
    begin
        ComboList.ItemIndex := -1;
        FPlayer.URL := '';
        FPlayer.currentMedia := nil;
    end;
end;

//-----------------------------------------------------------------------------
//  ЂƂ̃fBA
procedure TMainForm.SetNextMedia();
begin
    if (ComboList.Items.Count > ComboList.ItemIndex + 1) then
    begin
        ComboList.ItemIndex := ComboList.ItemIndex + 1;
        ComboList.OnSelect(ComboList);
    end
    //  Ȃ΃NA(ǃNAȂ)
    //  status uvɂȂ
    else
    begin
        FPlayer.URL := '';
        FPlayer.currentMedia := nil;
    end;
end;

//-----------------------------------------------------------------------------
//  fBAύX
procedure TMainForm.MenuNextMediaClick(Sender: TObject);
begin
    if (Sender = MenuPrevMedia) then SetPrevMedia()
    else
    if (Sender = MenuNextMedia) then SetNextMedia()
    ;
end;

//-----------------------------------------------------------------------------
//  Đ
procedure TMainForm.FPlayerPlayStateChange(Sender: TObject; NewState: Integer);
var
    LText: string;
begin
    if (Low(PLAY_STATE_STR) <= NewState) and (NewState <= High(PLAY_STATE_STR)) then
    begin
        LText := PLAY_STATE_STR[NewState]
    end
    else
    begin
        LText := 'Unknown';
    end;
    LblPlayState.Caption := LText;
end;

//-----------------------------------------------------------------------------
//  fBȀ
procedure TMainForm.FPlayerOpenStateChange(Sender: TObject; NewState: Integer);
var
    LText: string;
begin
    if (Low(OPEN_STATE_STR) <= NewState) and (NewState <= High(OPEN_STATE_STR)) then
    begin
        LText := OPEN_STATE_STR[NewState]
    end
    else
    begin
        LText := 'Unknown';
    end;
    LblOpenState.Caption := LText;
end;

//-----------------------------------------------------------------------------
//  Windows Media FPlayer ̏ԕύX
procedure TMainForm.FPlayerStatusChange(Sender: TObject);
begin
    //  ͂ݏoēǂ߂Ȃ̂Ńxɕ\[2008/01/18]
    LblStatusTxt.Caption := FPlayer.status;
end;

//-----------------------------------------------------------------------------
//  vC[̐ݒ𒲂ׂ
procedure TMainForm.MenuPlayerPropClick(Sender: TObject);
begin
    PropForm.ShowModal();
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.MenuVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  oX
procedure TMainForm.TrackBalanceChange(Sender: TObject);
begin
    FPlayer.settings.balance := TrackBalance.Position;
end;

//-----------------------------------------------------------------------------
//  TEhRg[N
procedure TMainForm.BtnSndVolClick(Sender: TObject);
begin
    SimpleShellExecute('sndvol32.exe');
end;

//-----------------------------------------------------------------------------
//  ݒ
procedure TMainForm.MenuConfClick(Sender: TObject);
begin
    ConfigForm.ShowModal();
end;

//-----------------------------------------------------------------------------
//  Đ̃t@CS~Ɏ̂Ă
procedure TMainForm.MenuTrashFileClick(Sender: TObject);
begin
    if (ComboList.ItemIndex = -1) then exit;
    SendToRecycleBin(ComboList.Text);
    SetNextMedia();
end;

//-----------------------------------------------------------------------------
//  Đ̃t@C̖OύX[2008/01/14]
procedure TMainForm.MenuRenameClick(Sender: TObject);
var
    LMedia: IWMPMedia;
    LMediaName: String;
    LFull: String;
    LPath: String;
    LExt: String;
    LOldName: String;
    LNewName: String;
    LChange: Boolean;
begin
    LMedia := FPlayer.currentMedia;
    if (LMedia <> nil) then
    begin
        LMediaName := LMedia.name; 
        LFull := FPlayer.URL;

        LPath := ExtractFilePath(LFull);
        LOldName := ChangeFileExt(ExtractFileName(LFull), '');
        LExt := ExtractFileExt(LFull);

        LNewName := LOldName;
        if (LOldName <> LMediaName) then
        begin
            LNewName := LNewName + LMediaName;
        end;

        LChange := InputQuery(
                    't@CύX',
                    LPath + #13#10 + LOldName + #13#10 + LExt,
                    LNewName);
        if (LChange) then
        begin
            RenameFile(LFull, LPath + LNewName + LExt);
        end;
    end;
end;

end.

